<?php
/*  cms-db  Copyright (C) 2007-2009 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */
include('checkuser.inc.php');
checkuser('blog');
include('locale.inc.php');
$locale = new LocalizingClass('blog');

if (isset($_POST['button_save'])) {
	$id = $_POST['id'];
	$filename = '../data/blog/articles/'.$id.'/content';
	$title = $_POST['title'];
	$tags = $_POST['tags'];
	$text = $_POST['content'];
	$text = stripslashes($text);
	if (file_exists($filename)) {
		$data = file_get_contents($filename);
		$data = explode("\n", $data, 5);
		$author = $data[1];
		$time = $data[2];
		$oldtags = $data[3];
	} else {
		include('../data/users/'.$_SESSION['CMS-User']);
		$author = $_SESSION['CMS-User'].'-'.$user;
		$time = time();
		$oldtags = '';
		mkdir('../data/blog/articles/'.$id);
	}
	include('mobile.inc.php');
	if (mobile()) {
		include('mobilemarkup.inc.php');
		$text = get_xhtml_from_mm($text);
	}
	if (is_writable($filename) || !file_exists('../data/blog/articles/'.$id.'/content')) {
		file_put_contents($filename, $title."\n".$author."\n".$time."\n".$tags."\n".$text);
		$oldtags = explode(' ', $oldtags);
		$newtags = explode(' ', $tags);
		$removedtags = array_diff($oldtags, $newtags);
		foreach ($removedtags as $tag) {
			if (file_exists('../data/blog/tags/'.$tag) && is_file('../data/blog/tags/'.$tag)) {
				$oldarticles = file_get_contents('../data/blog/tags/'.$tag);
				$oldarticles = explode("\n", $oldarticles);
				$articles = array();
				foreach($oldarticles as $article) {
					if ($article != $id) {
						$articles[] = $article;
					}
				}
				if (count($articles) != 0) {
					natsort($articles);
					$articles = implode("\n", $articles);
					file_put_contents('../data/blog/tags/'.$tag, $articles);
				} else {
					unlink('../data/blog/tags/'.$tag);
				}
			}
		}
		$addedtags = array_diff($newtags, $oldtags);
		foreach ($addedtags as $tag) {
			if (!is_dir('../data/blog/tags/'.$tag)) {
				if (file_exists('../data/blog/tags/'.$tag)) {
					$articles = file_get_contents('../data/blog/tags/'.$tag);
					$articles = explode("\n", $articles);
					$articles[] = $id;
					natsort($articles);
				} else {
					$articles = array($id);
				}
				$articles = implode("\n", $articles);
				file_put_contents('../data/blog/tags/'.$tag, $articles);
			}
		}
		include('cache.inc.php');
		clear_cache('blog');
		header('Location:blog.php?saved='.$id.'&'.SID);
	} else {
		include('error.inc.php');
		throw_error(sprintf(locale('desc_error-fileperms',true), $filename), 'blogentry.php?id='.$filename.'&'.SID);
	}
} elseif (isset($_GET['action_edit'])) {
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php locale('title_edit-blogentry') ?></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link rel="stylesheet" type="text/css" href="style.css">
		<style type="text/css">
		<!--
		input.date {
			text-align: center;
		}
		-->
		</style>
		<script type="text/javascript" src="jquery.js"></script>
		<script type="text/javascript">
		<!--
		$(function () {
			$("input.date").focus(function () {
				window.setTimeout($(this).select(), 100);
			});
		});
		//-->
		</script>
		</head>
		<?php
		include('../functions_url.inc.php');
		include('wymeditor.inc.php');
		include('keep-session-alive.inc.php');
		?>
		<noscript><?php locale('desc_javascript') ?></noscript>
	<body>

		<h1><?php locale('title_edit-blogentry') ?></h1>

		<?php
		$article = $_GET['id'];
		if (file_exists('../data/blog/articles/'.$article.'/content')) {
			$filename = '../data/blog/articles/'.$article.'/content';
			$data = file_get_contents($filename);
			$data = explode("\n", $data, 5);
			$title = $data[0];
			$author = $data[1];
			$time = $data[2];
			$tags = $data[3];
			$text = $data[4];
		} else {
			$title = '';
			$tags = '';
			$text = '';
		}
		?>
		<p>
			<form action="blogentry.php?<?php echo SID ?>" method="post">
				<input type="hidden" name="id" value="<?php echo $article ?>" />
				<label for="title"><?php locale('label_title') ?></label>
				<input type="text" name="title" id="title" value="<?php echo $title ?>" size="30" /><br />
				<label for="tags"><?php locale('label_tags') ?></label>
				<input type="text" name="tags" id="tags" value="<?php echo $tags ?>" size="30" /><br />
				<?php locale('desc_tags-howto') ?><br />
				<!--<label><?php locale('label_date') ?></label>
				<input class="date" type="text" name="date_y" value="" size="4" maxlength="4" />-<input class="date" type="text" name="date_m" value="" size="2" maxlength="2" />-<input class="date" type="text" name="date_d" value="" size="2" maxlength="2" />
				<input class="date" type="text" name="time_h" value="" size="2" maxlength="2" />:<input class="date" type="text" name="time_m" value="" size="2" maxlength="2" />:<input class="date" type="text" name="time_s" value="" size="2" maxlength="2" /><br />
				<?php locale('desc_date-howto') ?><br />--><br />
				<?php
				if (mobile()) {
					include('mobilemarkup.inc.php');
					$content = get_mm_from_xhtml($text);
				} else {
					$content = str_replace(array('&', '<', '>'),
						array('&amp;', '&lt;', '&gt;'), $text);
				}
				?>
				<textarea class="wymeditor" id="content" name="content" cols="80" rows="20"><?php echo $content ?></textarea><br />
				<div id="formbuttons">
					<input type="submit" name="button_save" value="<?php locale('button_save') ?>" class="wymupdate" />
				</div>
			</form>
		</p>

		<h2><?php locale('link_comments') ?></h2>

		<?php
		include('guestbook.inc.php');
		?>

	</body>
</html>
<?php
} elseif (isset($_POST['button_delete'])) {
	$id = $_POST['id'];
	$folder = '../data/blog/articles/'.$id;
	$filename_content = $folder.'/content';
	$filename_comments = $folder.'/comments';

	/*
	 * remove the tags
	 */
	$data = file_get_contents($filename_content);
	$data = explode("\n", $data, 5);
	$tags = explode(' ', $data[3]);
	foreach ($tags as $tag) {
		if (file_exists('../data/blog/tags/'.$tag) && is_file('../data/blog/tags/'.$tag)) {
			$oldarticles = file_get_contents('../data/blog/tags/'.$tag);
			$oldarticles = explode("\n", $oldarticles);
			$articles = array();
			foreach($oldarticles as $article) {
				if ($article != $id) {
					$articles[] = $article;
				}
			}
			if (count($articles) != 0) {
				natsort($articles);
				$articles = implode("\n", $articles);
				file_put_contents('../data/blog/tags/'.$tag, $articles);
			} else {
				unlink('../data/blog/tags/'.$tag);
			}
		}
	}

	/* delete files */
	unlink($filename_content);
	if (file_exists($filename_comments)) {
		unlink($filename_comments);
	}
	rmdir($folder);
	include('cache.inc.php');
	clear_cache('blog');
	header('Location:blog.php?deleted=a&'.SID);
} elseif (isset($_GET['action_delete'])) {
	$id = $_GET['id'];
	$filename = '../data/blog/articles/'.$id.'/content';
	$data = file_get_contents($filename);
	$data = explode("\n", $data, 5);
	$title = $data[0];
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><?php locale('title_delete-blogentry') ?></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<link rel="stylesheet" type="text/css" href="style.css">
	</head>
	<body>

	<h1><?php locale('title_delete-blogentry') ?></h1>

	<p>
		<?php printf(locale('desc_delete-blogentry',true), $title) ?>
		<form action="blogentry.php?<?php echo SID ?>" method="post">
			<input type="hidden" name="id" value="<?php echo $id ?>" />
			<input type="submit" name="button_delete" value="<?php locale('button_yes') ?>" />
			<a href="blog.php?<?php echo SID ?>" class="nonewtab"><?php locale('button_no') ?></a>
		</form>
	</p>

	</body>
</html>
<?php
}
?>
