<?php
/*  cms-db  Copyright (C) 2007-2009 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */
chdir('../');
include('checkuser.inc.php');
checkuser('root');
include('locale.inc.php');
$locale = new LocalizingClass('update');

$version = file_get_contents('../data/version.txt');
$version = substr($version, 1);
$version = trim($version);
$version = explode('.', $version);
$x1 = $version[0];
$x2 = $version[1];
if (isset($version[2])) {
	$x3 = $version[2];
} else {
	$x3 = 0;
}

function checkVersion($n1, $n2, $n3) {
	global $x1, $x2, $x3;
	if (($n1 > $x1)
	or ($n1 == $x1 and $n2 > $x2)
	or ($n1 == $x1 and $n2 == $x2 and $n3 > $x3)) {
		return true;
	} else {
		return false;
	}
}

include('cache.inc.php');

if (checkVersion(0,6,0)) {
	include('./update/convert_pages_to_sections.inc.php');
	convert_pages_to_sections();
	
	include('urlindex.inc.php');
	generate_urlindex();
	
	file_put_contents('../data/settings/locale.inc.php', '<?php
	$locale_default = "'.$_SESSION['CMS-Locale'].'";
	?>');
	
	if (file_exists('../data/stats/unknown.list')) {
		unlink('../data/stats/unknown.list');
	}
	if (file_exists('../data/stats/ip.list')) {
		unlink('../data/stats/ip.list');
	}
	$handle = opendir('../data/stats/browser');
	while (false !== ($file = readdir ($handle))) {
		if ($file != "." && $file != "..") {
			unlink('../data/stats/browser/'.$file);
		}
	}
	closedir($handle);
	$handle = opendir('../data/stats/os');
	while (false !== ($file = readdir ($handle))) {
		if ($file != "." && $file != "..") {
			unlink('../data/stats/os/'.$file);
		}
	}
	closedir($handle);
}

if (checkVersion(0,6,1)) {
	include('./update/convert_passwords_to_hashes.inc.php');
	convert_passwords_to_hashes();
}

if (checkVersion(0,7,0)) {
	include('../data/settings/common.inc.php');
	file_put_contents('../data/settings/common.inc.php', '<?php
	$hinweis = "'.$hinweis.'";
	$home = "'.$home.'";
	$newwindows = "";
	?>');

	$handle = opendir('../data/users');
	while (false !== ($file = readdir ($handle))) {
		if ($file != '.' && $file != '..' && $file != 'root.php') {
			include('../data/users/'.$file);
			file_put_contents('../data/users/'.$file, '<?php
			$user = "'.$_POST['user'].'";
			$pass = "'.$pass.'";
			$user_pages = "'.$_POST['pages'].'";
			$user_files = "'.$_POST['files'].'";
			$user_includes = "'.$_POST['includes'].'";
			$user_template = "'.$_POST['template'].'";
			$user_gbook = "";
			$user_blog = "'.$_POST['blog'].'";
			$user_stats = "'.$_POST['stats'].'";
			?>');
		}
	}
	closedir($handle);

	mkdir('../data/blog');
	mkdir('../data/blog/articles');
	mkdir('../data/blog/tags');

	mkdir('../data/cache');

	file_put_contents('../data/.htaccess', 'Order Deny,Allow
Deny from All
ErrorDocument 403 "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\"><html xmlns=\"http://www.w3.org/1999/xhtml\"><head><title>cms -db</title><meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\" /><style type=\"text/css\">/* <![CDATA[ */ html { padding: 0; margin: 0; } body { font-family: \"Bitstream Vera Sans\", Arial, Helvetica sans-serif; font-size: 10pt; padding: 0; margin: 1em; background: #eee; color: #000; } h1 { font-size: 4em; margin: -.25em -.25em 0 -.25em; padding: .25em; background: #ddd; border-bottom: .1em solid #bbb; font-weight: normal; color: #032b4f; } /* ]]> */</style></head><body><h1>cms -db</h1><h2>Error 403</h2><p>You\'re not allowed to access this file.</p></body></html>"');

	file_put_contents('../data/files/.htaccess', 'Allow from All');
}

if (checkVersion(0,7,2)) {
	clear_cache('blog');
}

if (checkVersion(0,7,3)) {
	include('../data/settings/common.inc.php');
	$writethis = '<?php
	$hinweis = "'.$hinweis.'";
	$home = "'.$home.'";
	$newwindows = "'.$newwindows.'";
	$cache = "";
	$xhtml = "on";
	?>';
	file_put_contents('../data/settings/common.inc.php', $writethis);
	clear_cache_complete();
}

if (checkVersion(0,7,6)) {
	unlink('../data/stats/ip.list');
}

if (checkVersion(0,7,8)) {
	unlink('../data/stats/ip.list');
}

copy('./update/version.txt', '../data/version.txt');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php locale('title') ?></title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="../style.css">
</head>
<body>

<h1><?php locale('title') ?></h1>
<p>
	<?php locale('desc') ?>
</p>
<?php
if (!isset($_GET['nolink'])) {
?>
<p>
	<a href="../frame.php?<?php echo SID ?>"><?php locale('link_next') ?></a>
</p>
<?php
}
?>

</body>
</html>
